
 GUI "BCX GLOSSY BUTTON TESTER"

 $include "guieffect.bas"

 GLOBAL Form1 AS HWND
 GLOBAL MainMenu   AS HMENU
 GLOBAL FileMenu   AS HMENU
 GLOBAL hStatus AS HWND
 GLOBAL hSLider AS HWND
 GLOBAL hSLiderGloss AS HWND 
 DIM Group1       AS  HWND
 DIM Buttons[17]   AS  HWND
 GLOBAL Label1 as HWND
 GLOBAL Label2 as HWND
 global bcx_export_code$

 
 CONST  ID_Edit     = 200
 CONST  ID_Exit     = 201

 SUB FORMLOAD
 BCX_SETMETRIC("pixels")
 
 Form1 = BCX_FORM("Glossy Buttons Demo 4 BCX", 0, 0, 800, 600)

 'removing CS_VREDRAW | CS_HREDRAW will prevent form1 from flickering on resize but I'm not sure what else will be affacted by this
 !SetClassLong(Form1, GCL_STYLE, GetClassLong(Form1, GCL_STYLE) & ~(CS_VREDRAW | CS_HREDRAW));  
 
 
 MainMenu   =  CreateMenu()
 FileMenu   =  CreateMenu() 
 AppendMenu(FileMenu,MF_STRING   ,ID_Exit  ,"E&xit")
 InsertMenu(MainMenu, ID_Edit , MF_POPUP , FileMenu ,"File")
 SetMenu(Form1,MainMenu)

 hSLider=bcx_slider("Gradient Contrast",Form1,250, 15, 375,450,35, 3) 
 SendMessage( hSLider, TBM_SETRANGE, TRUE, MAKELONG(-999,999))
 SendMessage( hSLider, TBM_SETPOS , (WPARAM) (BOOL)TRUE ,(LPARAM) (LONG) 800)
 
 hSLiderGloss =bcx_slider("Gloss Contrast",Form1,251, 15, 420,450,35, 3) 
 SendMessage( hSLiderGloss, TBM_SETRANGE, TRUE, MAKELONG(0,255))
 SendMessage( hSLiderGloss, TBM_SETPOS , (WPARAM) (BOOL)TRUE ,(LPARAM) (LONG)133)
 
 hStatus = BCX_STATUS(" Note: glossy effect is available only for buttons!", Form1)
 Label1 = BCX_LABEL("Right-click on any button to copy BCX code to clipboard.", Form1, 333, 300, 200, 300, 25)
 Label2 = BCX_LABEL("", Form1, 334, 300, 230, 400, 130)

 Dim i%
 For i = 0 to 6
   Buttons[i] = BCX_BUTTON("Button " & STR$(i) , Form1, 400+i, 15, 15+(51*i), 150, 50)
 Next    
 
 bcx_set_text Buttons[0], "Disable Button 1"
 Buttons[14] = BCX_BUTTON("Change Back Color", Form1, 500, 300, 15, 200, 50)
 Buttons[15] = BCX_BUTTON("Change Font Color", Form1, 600, 300, 75, 200, 50)
 Buttons[16] = BCX_BUTTON("Random Colors"    , Form1, 700, 300, 135,200, 50)

   
 Dim guief as GUI_EFFECT_SETUP
 guief.UseCachedImage = TRUE  ' FASTER, CURRENTLY NOT RECOMENDED IF CONTROLS ARE BEING RESIZED AT RUNTIME...
 guief.gfx_EffectType = GUI_EFFECT_GLOSSY
 
 
 'guief.forceStressTest = TRUE
 
 
 guief.gfx_GradientContrast =800
 guief.gfx_BaseColor = RGB(0, 64, 128)
 guief.gfx_FontColor = RGB(255,255,255)
 MakeEmGLossy(Form1, &guief) ' and now add glossy gui style to all button class controls
 
 
RANDOMIZE(TIMER)

 For i = 0 to 6
   Buttons[7+i] = BCX_BUTTON("Button " & STR$(i*2) , Form1, 800+i, 170, 15+(51*i), 100, 50)
   guief.gfx_BaseColor = RGB(rnd*120, rnd*120, rnd*120)
   SetGuiEffect(Buttons[7+i], &guief)
 Next    
 
 
 SetTimer(Form1, 1100, 4, NULL)
 CENTER(Form1)
 SHOW(Form1)
 END SUB

 BEGIN EVENTS
 SELECT CASE CBMSG
 
 Case WM_HSCROLL 
    If hSLider = (HWND)lParam Then 
        dim raw slipos%
        slipos% = (int)SendMessage(hSLider, TBM_GETPOS, 0, 0)
        SetWindowText(hStatus,"Gradient Contrast: " & str$(slipos))
        ChangeControlContrast(Form1, slipos)
    End If 
    
    If hSLiderGloss = (HWND)lParam Then 
        dim raw slipos%
        slipos% = (int)SendMessage(hSLiderGloss, TBM_GETPOS, 0, 0)
        SetWindowText(hStatus,"Gloss Contrast: " & str$(slipos))
        ChangeAlphaContrast(Form1, slipos)
    End If     
    
  CASE WM_COMMAND
   SetWindowText(hStatus,"WM_COMMAND - Control ID:" & str$(CBCTL))
       
   Select case CBCTL
   Case 400
    auto chkEn as BOOL
    chkEn = 1 XOR IsWindowEnabled(Buttons[1])
    EnableWindow(Buttons[1], chkEn)
   
   Case 500
     ChangeControlBackground(Form1, BCX_COLORDLG(  RGB(0, 64, 128), Form1))

   Case 600
     ChangeControlFontColor(Form1, BCX_COLORDLG(  RGB(255,255,255), Form1))

   Case 700
     ChangeControlBackground(Form1, -1)
     
     
   End Select     
  
  case WM_CTLCOLORSTATIC      
    If (HWND) lParam = Label1 or (HWND) lParam = Label2 Then
      SetBkMode((HDC)wParam, TRANSPARENT)
      SetTextColor((HDC)wParam,rgb(255,255,128))
      Function =(INT_PTR)GetStockObject(NULL_BRUSH)  
    End If

  Case WM_CONTEXTMENU 
    'hwnd = (HWND) wParam  
    'xPos = LOWORD(lParam)
    'yPos = HIWORD(lParam)
    Dim i
    For i = 0 to 16
     If Buttons[i] = (HWND) wParam Then
        $ccode
        GUI_EFFECT* gfxptr = (GUI_EFFECT*)LongToPtr(GetWindowLongPtr((HWND) wParam, GWLP_USERDATA));
        
        wsprintf(bcx_export_code, 
        "' Copy file 'guieffect.bas' to your project folder.\r\n"
        "' -- BCX Code for Buttons with Glossy Effect. By Ljubisa Knezevic Jan.2009 --\r\n\r\n"
        "%s\r\n\r\n %s\r\n %s\r\n %s\r\n %s%d\r\n %s RGB(%d,%d,%d)\r\n %s RGB(%d,%d,%d)\r\n %s\r\n\r\n %s\r\n %s",
        "$include \"guieffect.bas\" 'add at the top of your code",
        "Dim guief as GUI_EFFECT_SETUP ' at this code after button has been created with BCX_BUTTON or similar",
        "guief.UseCachedImage = TRUE",
        "guief.gfx_EffectType = GUI_EFFECT_GLOSSY",
        "guief.gfx_GradientContrast=", (gfxptr->gfx.gfx_GradientContrast*-1),
        "guief.gfx_BaseColor = ",
          GetRValue(gfxptr->gfx.gfx_BaseColor), 
          GetGValue(gfxptr->gfx.gfx_BaseColor), 
          GetBValue(gfxptr->gfx.gfx_BaseColor),
        "guief.gfx_FontColor = ",
          GetRValue(gfxptr->gfx.gfx_FontColor), 
          GetGValue(gfxptr->gfx.gfx_FontColor), 
          GetBValue(gfxptr->gfx.gfx_FontColor),
          "SetGuiEffect(hCtl, &guief) ' to set style of single button",
          "' or call MakeEmGLossy to add glossy style to all buttons on form:",          
          "' Example: MakeEmGLossy(Form1, &guief)"
        );
        $ccode
        SetClipBoard(bcx_export_code)
        SetWindowText(hStatus,"Code copied to clipoboard!")
        SetWindowText(Label2, "Code copied to clipoboard!")
     End If
    Next i  
  CASE WM_PAINT
   Dim ps as PAINTSTRUCT
   DIM rc as RECT
   BeginPaint (hWnd, &ps);
   GetClientRect (hWnd, (LPRECT) &rc);   
   PaintGradient(ps.hdc, &rc, rgb(50,80,180),rgb(10,40,100), GRADIENT_FILL_RECT_H)
   EndPaint (hWnd, &ps);


   CASE WM_CLOSE
    Release_bcx_gfx_Libs()
    DestroyWindow(Form1)
    EXIT FUNCTION
   
 END SELECT
 END EVENTS

' =================================================================================================================================


SUB SetClipBoard (Text$)
   LOCAL nd  AS HANDLE
   LOCAL ns$ AS LPSTR
   nd  = GlobalAlloc(GHND, LEN(Text$) + 1)
   ns  = GlobalLock(nd)
   ns$ = Text$
   GlobalUnlock(nd)
   OpenClipboard(0)
   EmptyClipboard()
   SetClipboardData(CF_TEXT, nd)
   CloseClipboard()
 END SUB



